@echo off
REM # This is a sample `NOTEFILE.CMD` Windows batch file to be called from NOTEFILE.
REM # © 2021 Fedon Kadifeli. 
REM # You can freely edit this file. For more info:
REM # https://kadifeli.com/fedon/notefile.php/T_RELOAD
REM # Note: Some commands called by this script may not be available in your system.
REM # For example, `POWERSHELL` is provided only on Windows 7 and above.

if "%~1" == "1" (
  REM ## Sort input lines:
  sort
) else if "%~1" == "2" (
  REM ## Fill to the max size (500,000 characters) of a card:
  REM ## Unfortunately this is too slow. :(
  for /L %%c in (1,1,5000) do echo 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678
  REM ## This is also slow. :(
  REM powershell "for ($i=0; $i -lt 5000; $i++) { write-host 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678`r }"
) else if "%~1" == "3" (
  REM ## Calculate an expression with a temporary script:
  del notefile_cmd_temp.vbs 2>NUL
  (
    echo Do While Not WScript.StdIn.AtEndOfStream
    echo   WScript.Echo Eval^(Wscript.StdIn.ReadLine^)
    echo Loop
  ) >notefile_cmd_temp.vbs
  cscript //nologo notefile_cmd_temp.vbs
  del notefile_cmd_temp.vbs 2>NUL
) else if "%~1" == "4" (
  REM ## Calculate an expression with `powershell`:
  REM ## (Powershell echoes the original expression also.)
  powershell -NoLogo -Command Invoke-Expression
) else if "%~1" == "14" (
  REM ## Echo date in a specific format:
  powershell Get-Date -UFormat "{%%a %%b %%d %%T %%Z %%Y}"
) else if "%~1" == "15" (
  REM ## The `FIND` command will count only the lines:
  echo Number of lines: >&2
  find /v /c "" >&2
  exit /b 0
) else if "%~1" == "16" (
  REM ## Convert IP to country information:
  powershell -Command "$ip=Read-Host ; Invoke-WebRequest https://freegeoip.app/json/$ip | Select-Object -Expand Content | ConvertFrom-Json"
  REM ## Or: powershell -Command "$ip=Read-Host ; Invoke-WebRequest https://api.ip2country.info/ip?$ip | Select-Object -Expand Content | ConvertFrom-Json"
) else if "%~1" == "17" (
  REM ## Convert Country_Code/ZIP to place information:
  REM ##  Sample input data: US/97818 or TR/34746
  powershell -Command "$c_ip=Read-Host ; Invoke-WebRequest https://api.zippopotam.us/$c_ip | Select-Object -Expand Content | ConvertFrom-Json | Select-Object -Expand places"
) else if "%~1" == "19" (
  REM ## Just for test:
  set /p ="Going to sleep... " <NUL
  REM ## ?? choice /t 2 /d n /n >NUL
  ping 127.0.0.1 -n 2 >NUL
  echo Woke up!
) else if "%~1" == "121" (
  REM ## Run `DIR` with given "parameter":
  dir %~2
) else if "%~1" == "122" (
  REM ## Run the given "parameter" as a complete command:
  cmd /c %~2
) else if "%~1" == "23" (
  REM ## Return error code:
  REM ##  echo This is an error! >&2
  exit /b 33
) else if "%~1" == "" (
  echo   1 ^&Sort
  echo   2 ^&Fill Card
  echo   3 Calculate E^&xpresssion with CScript
  echo   4 Calculate Expresssion with Po^&werShell
  echo  14 Insert ^&Date ^&^& Time
  echo  15 Line ^&Count...
  echo  16 Convert ^&IP to Region
  echo  17 Convert Country_Code/^&ZIP to Place Info
  echo  19 ^&Sleep
  echo 121 "DIR" With ^&Parameter
  echo 122 ^&Any Command
  echo  23 ^&Error...
) else (
  echo Unknown parameter ^(%~1^)! >&2
  exit /b 255
)
